/*
 * *************************************************
 * Copyright (c) 2018 QMTH. All Rights Reserved.
 * Created by Deason on 2018-10-22 15:24:57.
 * *************************************************
 */

package cn.com.qmth.examcloud.core.print.service;

import cn.com.qmth.examcloud.core.print.service.bean.coursepaper.CoursePaperInfo;
import cn.com.qmth.examcloud.core.print.service.bean.coursepaper.CoursePaperQuery;
import cn.com.qmth.examcloud.core.print.service.bean.coursepaper.CoursePaperTotalInfo;

import java.io.File;
import java.util.List;

/**
 * @author: fengdesheng
 * @since: 2018/10/22
 */
public interface CoursePaperService {

    /**
     * 获取课程试卷列表
     */
    List<CoursePaperInfo> getCoursePaperList(CoursePaperQuery query);

    /**
     * 同步更新课程名称信息
     */
    void syncCourseNameByCourseId(Long courseId, String courseName);

    /**
     * 下载考试结构
     */
    File downloadPaperStructure(Long examId, Long paperId);

    /**
     * 校验考试结构
     */
    void checkPaperStructure(Long examId, Long paperId);

    /**
     * (单个)分配待指定试卷
     *
     * @param courseStatisticId 课程统计ID
     * @param coursePaperId     课程试卷ID
     */
    void allotCoursePaper(Long courseStatisticId, Long coursePaperId);

    /**
     * (整体)分配待指定试卷
     */
    void allotAllCoursePaper(Long orgId, Long examId);

    /**
     * 获取某学校考试的试卷数量情况
     */
    CoursePaperTotalInfo getPaperTotalByOrgIdAndExamId(Long orgId, Long examId);

    /**
     * 整体导出(导出考试下所有试卷文件)
     */
    File exportAllByOrgIdAndExamId(Long orgId, Long examId);

    /**
     * 批量导出
     */
    File exportBatchByIds(Long[] ids);

}